/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.18 Revision 1.37
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.18 2009/05/09 13:23:15 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.37 2010/05/17 01:16:39 reavertm Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
14 14
15inherit kde4-base versionator 15inherit kde4-base versionator
16 16
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
18 18
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22
23case ${KDEBASE} in
24 kde-base)
25 HOMEPAGE="http://www.kde.org/"
26 LICENSE="GPL-2"
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33
34# Add khelpcenter dependency when installing
35if [[ ${PN} != khelpcenter ]] && has doc ${IUSE//+} && use doc; then
36 RDEPEND="${RDEPEND}
37 >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=]
38 "
39fi
40 20
41# Add dependencies that all packages in a certain module share. 21# Add dependencies that all packages in a certain module share.
42case ${KMNAME} in 22case ${KMNAME} in
43 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphic) 23 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
44 DEPEND="${DEPEND} 24 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
45 >=kde-base/qimageblitz-0.0.4
46 "
47 RDEPEND="${RDEPEND}
48 >=kde-base/qimageblitz-0.0.4
49 "
50 ;; 25 ;;
51 kdenetwork) 26 kdepim|kdepim-runtime)
52 DEPEND="${DEPEND} 27 ! slot_is_at_least 4.4 ${SLOT} && COMMONDEPEND+=" $(add_kdebase_dep kdepimlibs)"
53 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
54 "
55 RDEPEND="${RDEPEND}
56 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
57 "
58 ;;
59 kdepim)
60 DEPEND="${DEPEND}
61 dev-libs/boost
62 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
63 "
64 RDEPEND="${RDEPEND}
65 dev-libs/boost
66 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
67 "
68 case ${PN} in 28 case ${PN} in
69 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
70 IUSE="+kontact" 30 IUSE+=" +kontact"
71 RDEPEND="${RDEPEND} 31 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
72 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )
73 "
74 ;; 32 ;;
75 esac 33 esac
76 ;; 34 ;;
77 kdegames) 35 kdegames)
78 if [[ ${PN} != libkdegames ]]; then 36 if [[ ${PN} != libkdegames ]]; then
79 DEPEND="${DEPEND} 37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
80 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
81 "
82 RDEPEND="${RDEPEND}
83 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
84 "
85 fi 38 fi
86 ;; 39 ;;
87 koffice) 40 koffice)
88 [[ ${PN} != koffice-data ]] && IUSE="debug" 41 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
89 RDEPEND="${RDEPEND} 42 RDEPEND+="
90 !kdeprefix? (
91 !app-office/${PN}:0 43 !app-office/${PN}:0
92 !app-office/koffice:0 44 !app-office/koffice:0
93 !app-office/koffice-meta:0 45 !app-office/koffice-meta:0
94 )
95 " 46 "
47 if has openexr ${IUSE//+}; then
48 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
49 else
50 COMMONDEPEND+=" media-gfx/imagemagick"
51 fi
52
96 COMMON_DEPEND=" 53 COMMONDEPEND+="
97 dev-cpp/eigen:2 54 dev-cpp/eigen:2
98 media-gfx/imagemagick[openexr?]
99 media-libs/fontconfig 55 media-libs/fontconfig
100 media-libs/freetype:2 56 media-libs/freetype:2
101 " 57 "
102 DEPEND="${DEPEND} ${COMMON_DEPEND}"
103 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
104 unset COMMON_DEPEND
105 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 58 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
106 DEPEND="${DEPEND}
107 >=app-office/koffice-libs-${PV}:${SLOT} 59 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
108 "
109 RDEPEND="${RDEPEND}
110 >=app-office/koffice-libs-${PV}:${SLOT}
111 "
112 fi 60 fi
113 ;; 61 ;;
114esac 62esac
63
64DEPEND+=" ${COMMONDEPEND}"
65RDEPEND+=" ${COMMONDEPEND}"
66unset COMMONDEPEND
115 67
116debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
117debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 69debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
118 70
119# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 71# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
155 107
156# @ECLASS-VARIABLE: KMEXTRA 108# @ECLASS-VARIABLE: KMEXTRA
157# @DESCRIPTION: 109# @DESCRIPTION:
158# All subdirectories listed here will be extracted, compiled & installed. 110# All subdirectories listed here will be extracted, compiled & installed.
159# $KMMODULE is always added to $KMEXTRA. 111# $KMMODULE is always added to $KMEXTRA.
160# If the htmlhandbook USE-flag is set, and if this directory exists, 112# If the handbook USE-flag is set, and if this directory exists,
161# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 113# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be
162# handled in the ebuild. 114# handled in the ebuild.
163# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 115# If the documentation is in a different subdirectory, you should add it to KMEXTRA.
164 116
165# @ECLASS-VARIABLE: KMCOMPILEONLY 117# @ECLASS-VARIABLE: KMCOMPILEONLY
250 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 202 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
251 fi 203 fi
252 else 204 else
253 local abort tarball tarfile f extractlist moduleprefix postfix 205 local abort tarball tarfile f extractlist moduleprefix postfix
254 case ${PV} in 206 case ${PV} in
255 4.2.85) 207 4.[34].8[05] | 4.[34].9[0568])
256 # block for normally packed upstream unstable snapshots 208 # block for normally packed upstream unstable snapshots
257 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 209 KMTARPARAMS+=" --bzip2" # bz2
258 postfix="bz2" 210 postfix="bz2"
259 ;; 211 ;;
260 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) 212 4.[34].[6-9]*)
261 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma 213 # Not passing --xz, as it doesn't work with stable tar
214 KMTARPARAMS+=" --use-compress-program=xz" # xz
262 postfix="lzma" 215 postfix="xz"
263 ;; 216 ;;
264 *) 217 *)
265 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 218 KMTARPARAMS+=" --bzip2" # bz2
266 postfix="bz2" 219 postfix="bz2"
267 ;; 220 ;;
268 esac 221 esac
269 case ${KMNAME} in 222 case ${KMNAME} in
270 kdebase-apps) 223 kdebase-apps)
271 # kdebase/apps -> kdebasa-apps 224 # kdebase/apps -> kdebase-apps
272 tarball="kdebase-${PV}.tar.${postfix}" 225 tarball="kdebase-${PV}.tar.${postfix}"
273 # Go one level deeper for kdebase-apps in tarballs 226 # Go one level deeper for kdebase-apps in tarballs
274 moduleprefix=apps/ 227 moduleprefix=apps/
275 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||" 228 KMTARPARAMS+=" --transform=s|apps/||"
276 ;; 229 ;;
277 *) 230 *)
278 # Create tarball name from module name (this is the default) 231 # Create tarball name from module name (this is the default)
279 tarball="${KMNAME}-${PV}.tar.${postfix}" 232 tarball="${KMNAME}-${PV}.tar.${postfix}"
280 ;; 233 ;;
281 esac 234 esac
282 235
283 # Full patch to source tarball 236 # Full path to source tarball
284 tarfile="${DISTDIR}/${tarball}" 237 tarfile="${DISTDIR}/${tarball}"
285 238
286 # Detect real toplevel dir from tarball name - it will be used upon extraction 239 # Detect real toplevel dir from tarball name - it will be used upon extraction
287 # and in __list_needed_subdirectories 240 # and in __list_needed_subdirectories
288 topdir="${tarball%.tar.*}/" 241 topdir="${tarball%.tar.*}/"
292 kde4-meta_create_extractlists 245 kde4-meta_create_extractlists
293 246
294 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 247 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
295 AUTHORS COPYING INSTALL README NEWS ChangeLog 248 AUTHORS COPYING INSTALL README NEWS ChangeLog
296 do 249 do
297 extractlist="${extractlist} ${topdir}${moduleprefix}${f}" 250 extractlist+=" ${topdir}${moduleprefix}${f}"
298 done 251 done
299 extractlist="${extractlist} $(__list_needed_subdirectories)" 252 extractlist+=" $(__list_needed_subdirectories)"
300 253
301 pushd "${WORKDIR}" > /dev/null 254 pushd "${WORKDIR}" > /dev/null
302 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 255 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2
303 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 256 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null
304 257
334# KMEXTRACTONLY and KMTARPARAMS. 287# KMEXTRACTONLY and KMTARPARAMS.
335kde4-meta_create_extractlists() { 288kde4-meta_create_extractlists() {
336 debug-print-function ${FUNCNAME} "$@" 289 debug-print-function ${FUNCNAME} "$@"
337 290
338 # TODO change to KMEXTRA for more strict check 291 # TODO change to KMEXTRA for more strict check
339 if has doc ${IUSE//+} && use doc && [[ -n ${KMMODULE} ]]; then 292 if has handbook ${IUSE//+} && use handbook && [[ -n ${KMMODULE} ]]; then
340 # We use the basename of $KMMODULE because $KMMODULE can contain 293 # We use the basename of $KMMODULE because $KMMODULE can contain
341 # the path to the module subdirectory. 294 # the path to the module subdirectory.
342 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 295 KMEXTRA_NONFATAL+="
296 doc/${KMMODULE##*/}"
343 fi 297 fi
344 298
345 # Add some CMake-files to KMEXTRACTONLY. 299 # Add some CMake-files to KMEXTRACTONLY.
346 # Note that this actually doesn't include KMEXTRA handling. 300 # Note that this actually doesn't include KMEXTRA handling.
347 # In those cases you should care to add the relevant files to KMEXTRACTONLY 301 # In those cases you should care to add the relevant files to KMEXTRACTONLY
348 case ${KMNAME} in 302 case ${KMNAME} in
349 kdebase) 303 kdebase)
350 KMEXTRACTONLY="${KMEXTRACTONLY} 304 KMEXTRACTONLY+="
351 apps/config-apps.h.cmake 305 apps/config-apps.h.cmake
352 apps/ConfigureChecks.cmake" 306 apps/ConfigureChecks.cmake"
353 ;; 307 ;;
354 kdebase-apps) 308 kdebase-apps)
355 KMEXTRACTONLY="${KMEXTRACTONLY} 309 KMEXTRACTONLY+="
356 config-apps.h.cmake 310 config-apps.h.cmake
357 ConfigureChecks.cmake" 311 ConfigureChecks.cmake"
358 ;; 312 ;;
359 kdebase-runtime) 313 kdebase-runtime)
360 KMEXTRACTONLY="${KMEXTRACTONLY} 314 KMEXTRACTONLY+="
361 config-runtime.h.cmake" 315 config-runtime.h.cmake"
362 ;; 316 ;;
363 kdebase-workspace) 317 kdebase-workspace)
364 KMEXTRACTONLY="${KMEXTRACTONLY} 318 KMEXTRACTONLY+="
365 config-unix.h.cmake 319 config-unix.h.cmake
366 ConfigureChecks.cmake 320 ConfigureChecks.cmake
367 config-workspace.h.cmake 321 config-workspace.h.cmake
368 config-X11.h.cmake 322 config-X11.h.cmake
369 startkde.cmake 323 startkde.cmake
370 KDE4WorkspaceConfig.cmake.in" 324 KDE4WorkspaceConfig.cmake.in"
371 ;; 325 ;;
372 kdegames) 326 kdegames)
373 if [[ ${PN} != libkdegames ]]; then 327 if [[ ${PN} != libkdegames ]]; then
374 KMEXTRACTONLY="${KMEXTRACTONLY} 328 KMEXTRACTONLY+="
375 libkdegames" 329 libkdegames/"
330 KMLOADLIBS="${KMLOADLIBS} libkdegames"
376 fi 331 fi
377 ;; 332 ;;
378 kdepim) 333 kdepim)
379 if [[ ${PN} != libkdepim ]]; then 334 if [[ ${PN} != libkdepim ]]; then
380 KMEXTRACTONLY="${KMEXTRACTONLY} 335 KMEXTRACTONLY+="
381 libkdepim" 336 libkdepim/"
382 fi 337 fi
383 case ${SLOT} in 338 KMEXTRACTONLY+="
384 4.3|live)
385 KMEXTRACTONLY="${KMEXTRACTONLY}
386 kdepim-version.h
387 config-enterprise.h.cmake" 339 config-enterprise.h.cmake
388 ;;
389 esac
390 KMEXTRACTONLY="${KMEXTRACTONLY}
391 kleopatra/ConfigureChecks.cmake" 340 kleopatra/ConfigureChecks.cmake"
341 if slot_is_at_least 4.5 ${SLOT}; then
342 KMEXTRACTONLY+="
343 CTestCustom.cmake
344 kdepim-version.h.cmake"
345 else
346 KMEXTRACTONLY+="
347 kdepim-version.h"
348 fi
392 if has kontact ${IUSE//+} && use kontact; then 349 if has kontact ${IUSE//+} && use kontact; then
350 KMEXTRA+="
393 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 351 kontact/plugins/${PLUGINNAME:-${PN}}/"
394 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/" 352 if ! slot_is_at_least 4.4 ${SLOT}; then
353 KMEXTRACTONLY+="
354 kontactinterfaces/"
395 fi 355 fi
356 fi
357 ;;
358 kdeutils)
359 KMEXTRACTONLY+="
360 kdeutils-version.h"
396 ;; 361 ;;
397 koffice) 362 koffice)
398 KMEXTRACTONLY="${KMEXTRACTONLY} 363 KMEXTRACTONLY+="
399 config-endian.h.cmake 364 config-endian.h.cmake
400 filters/config-filters.h.cmake 365 filters/config-filters.h.cmake
401 config-openctl.h.cmake
402 config-openexr.h.cmake 366 config-openexr.h.cmake
403 config-opengl.h.cmake 367 config-opengl.h.cmake
404 config-prefix.h.cmake" 368 config-prefix.h.cmake
369 "
370 case ${PV} in
371 2.0.*)
372 KMEXTRACTONLY+="
373 config-openctl.h.cmake"
374 ;;
375 esac
405 ;; 376 ;;
406 esac 377 esac
407 # Don't install cmake modules for split ebuilds, to avoid collisions. 378 # Don't install cmake modules for split ebuilds, to avoid collisions.
408 case ${KMNAME} in 379 case ${KMNAME} in
409 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 380 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
410 case ${PN} in 381 case ${PN} in
411 libkdegames|libkdeedu|libkworkspace) 382 libkdegames|libkdeedu|libkworkspace)
412 KMEXTRA="${KMEXTRA} 383 KMEXTRA+="
413 cmake/modules/" 384 cmake/modules/"
414 ;; 385 ;;
415 *) 386 *)
416 KMCOMPILEONLY="${KMCOMPILEONLY} 387 KMCOMPILEONLY+="
417 cmake/modules/" 388 cmake/modules/"
418 ;; 389 ;;
419 esac 390 esac
420 ;; 391 ;;
421 esac 392 esac
426__list_needed_subdirectories() { 397__list_needed_subdirectories() {
427 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist 398 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
428 399
429 # We expand KMEXTRA by adding CMakeLists.txt files 400 # We expand KMEXTRA by adding CMakeLists.txt files
430 kmextra="${KMEXTRA}" 401 kmextra="${KMEXTRA}"
431 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 402 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
432 for i in ${kmextra}; do 403 for i in ${kmextra}; do
433 kmextra_expanded="${kmextra_expanded} ${i}" 404 kmextra_expanded+=" ${i}"
434 j=$(dirname ${i}) 405 j=$(dirname ${i})
435 while [[ ${j} != "." ]]; do 406 while [[ ${j} != "." ]]; do
436 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 407 kmextra_expanded+=" ${j}/CMakeLists.txt";
437 j=$(dirname ${j}) 408 j=$(dirname ${j})
438 done 409 done
439 done 410 done
440 411
441 # Expand KMMODULE 412 # Expand KMMODULE
442 if [[ -n ${KMMODULE} ]]; then 413 if [[ -n ${KMMODULE} ]]; then
443 kmmodule_expanded="${KMMODULE}" 414 kmmodule_expanded="${KMMODULE}"
444 j=$(dirname ${KMMODULE}) 415 j=$(dirname ${KMMODULE})
445 while [[ ${j} != "." ]]; do 416 while [[ ${j} != "." ]]; do
446 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 417 kmmodule_expanded+=" ${j}/CMakeLists.txt";
447 j=$(dirname ${j}) 418 j=$(dirname ${j})
448 done 419 done
449 fi 420 fi
450 421
451 # Expand KMCOMPILEONLY 422 # Expand KMCOMPILEONLY
452 for i in ${KMCOMPILEONLY}; do 423 for i in ${KMCOMPILEONLY}; do
453 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 424 kmcompileonly_expanded+=" ${i}"
454 j=$(dirname ${i}) 425 j=$(dirname ${i})
455 while [[ ${j} != "." ]]; do 426 while [[ ${j} != "." ]]; do
456 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 427 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
457 j=$(dirname ${j}) 428 j=$(dirname ${j})
458 done 429 done
459 done 430 done
460 431
461 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 432 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
465 # Create final list of stuff to extract 436 # Create final list of stuff to extract
466 # We append topdir only when specified (usually for tarballs) 437 # We append topdir only when specified (usually for tarballs)
467 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 438 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
468 ${KMEXTRACTONLY} 439 ${KMEXTRACTONLY}
469 do 440 do
470 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 441 extractlist+=" ${topdir}${moduleprefix}${i}"
471 done 442 done
472 443
473 echo ${extractlist} 444 echo ${extractlist}
474} 445}
475 446
499 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 470 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
500 fi 471 fi
501 done 472 done
502} 473}
503 474
504# FIXME: add description
505# @FUNCTION: kde4-meta_change_cmakelists 475# @FUNCTION: kde4-meta_change_cmakelists
506# @DESCRIPTION: 476# @DESCRIPTION:
477# Adjust CMakeLists.txt to comply to our splitting.
507kde4-meta_change_cmakelists() { 478kde4-meta_change_cmakelists() {
508 debug-print-function ${FUNCNAME} "$@" 479 debug-print-function ${FUNCNAME} "$@"
509 480
510 pushd "${S}" > /dev/null 481 pushd "${S}" > /dev/null
511 482
512 comment_all_add_subdirectory ./ 483 comment_all_add_subdirectory ./
513 484
514 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 485 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
515 if [[ -f "${S}"/CMakeLists.txt ]]; then 486 if [[ -f CMakeLists.txt ]]; then
516 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 487 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
517 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 488 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
518 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 489 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
519 fi 490 fi
520 491
521 if [[ -z ${KMNOMODULE} ]]; then 492 if [[ -z ${KMNOMODULE} ]]; then
522 # Restore "add_subdirectory" in $KMMODULE subdirectories 493 # Restore "add_subdirectory" in $KMMODULE subdirectories
523 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 494 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
495 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
524 die "${LINENO}: died in KMMODULE section" 496 die "${LINENO}: died in KMMODULE section"
525 _change_cmakelists_parent_dirs ${KMMODULE} 497 _change_cmakelists_parent_dirs ${KMMODULE}
526 fi 498 fi
527 499
528 local i 500 local i
529 501
530 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 502 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
531 for i in ${KMEXTRACTONLY}; do 503 for i in ${KMEXTRACTONLY}; do
532 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 504 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
533 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 505 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
506 -i ${i}/../CMakeLists.txt || \
534 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 507 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
535 fi 508 fi
536 done 509 done
537 510
538 # KMCOMPILEONLY 511 # KMCOMPILEONLY
560 # KMEXTRA_NONFATAL section 533 # KMEXTRA_NONFATAL section
561 for i in ${KMEXTRA_NONFATAL}; do 534 for i in ${KMEXTRA_NONFATAL}; do
562 if [[ -d "${S}"/${i} ]]; then 535 if [[ -d "${S}"/${i} ]]; then
563 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 536 find "${S}"/${i} -name CMakeLists.txt -print0 | \
564 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 537 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
565 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 538 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
566 _change_cmakelists_parent_dirs ${i} 539 _change_cmakelists_parent_dirs ${i}
567 fi 540 fi
568 done 541 done
569 542
570 case ${KMNAME} in 543 case ${KMNAME} in
571 kdebase-workspace) 544 kdebase-workspace)
572 # COLLISION PROTECT section 545 # COLLISION PROTECT section
573 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 546 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
574 # not as a part of every package. 547 # not as a part of every package.
575 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 548 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
576 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 549 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
577 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 550 sed -e '/startkde/s/^/#DONOTINSTALL /' \
578 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 551 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
579 fi 552 fi
580 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 553 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
581 if [[ ${PN} != libkworkspace ]]; then 554 if [[ ${PN} != libkworkspace ]]; then
582 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 555 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
583 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 556 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
584 fi 557 fi
585 ;; 558 ;;
586 kdebase-runtime) 559 kdebase-runtime)
587 # COLLISION PROTECT section 560 # COLLISION PROTECT section
588 # Only install the kde4 script as part of kde-base/kdebase-data 561 # Only install the kde4 script as part of kde-base/kdebase-data
589 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 562 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
590 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 563 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
591 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 564 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
592 fi 565 fi
593 ;;
594 kdepim)
595 case ${PN} in
596 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn)
597 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
598 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed"
599 _change_cmakelists_parent_dirs kmail
600 ;; 566 ;;
601 esac 567 kdenetwork)
602 ;;
603 kdewebdev)
604 # Disable hardcoded kdepimlibs check 568 # Disable hardcoded kdepimlibs check
605 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \ 569 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
606 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2 REQUIRED)/' \
607 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt REQUIRED)/' \
608 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost REQUIRED)/' \
609 -i CMakeLists.txt || die "failed to disable hardcoded checks" 570 -i CMakeLists.txt || die "failed to disable hardcoded checks"
610 ;; 571 ;;
572 kdepim)
573 # Disable hardcoded checks
574 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
575 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
576 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
577 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
578 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
579 -i CMakeLists.txt || die "failed to disable hardcoded checks"
580 # Disable broken or redundant build logic
581 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
582 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
583 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
584 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
585 fi
586 if ! slot_is_at_least 4.5 ${SLOT}; then
587 case ${PN} in
588 kalarm|kmailcvt|kontact|korganizer|korn)
589 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
590 -e '/add_custom_target(kmail_xml /,/)/p' \
591 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
592 _change_cmakelists_parent_dirs kmail
593 ;;
594 esac
595 fi
596 ;;
597 kdewebdev)
598 # Disable hardcoded checks
599 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
600 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
601 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
602 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
603 -i CMakeLists.txt || die "failed to disable hardcoded checks"
604 ;;
611 koffice) 605 koffice)
612 # prevent collisions 606 # Prevent collisions
613 if [[ ${PN} != koffice-data ]]; then 607 if [[ ${PN} != koffice-data ]]; then
614 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 608 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
615 "${S}"/cmake/modules/CMakeLists.txt || \ 609 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
610 sed -e '/install(.\+config-openexr\.h.\+)/d' \
616 die "${LINENO}: sed died in collision prevention section" 611 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
612 fi
613 # koffice 2.0
614 case ${PV} in
615 2.0.[1-9])
617 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \ 616 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
618 "${S}"/CMakeLists.txt || \ 617 "${S}"/CMakeLists.txt || \
619 die "${LINENO}: sed died in collision prevention section" 618 die "${LINENO}: sed died in collision prevention section"
619 ;;
620 *) ;;
621 esac
622 # koffice 2.1.[8-9][0-9] and 9999
623 case ${PV} in
624 2.1.8[0-9]|2.1.9[0-9]|9999)
625 sed -e '/^option(BUILD/s/ON/OFF/' \
626 -e '/^if(NOT BUILD_kchart/,/^endif(NOT BUILD_kchart/d' \
627 -e '/^if(BUILD_koreport/,/^endif(BUILD_koreport/d' \
628 -e 's/set(SHOULD_BUILD_F_OFFICE TRUE)/set(SHOULD_BUILD_F_OFFICE FALSE)/' \
629 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
630 if [[ ${PN} != koffice-data ]] && [[ ${PV} == 9999 ]]; then
631 sed -e '/config-opengl.h/d' \
632 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
633
620 fi 634 fi
635 ;;
636 *) ;;
637 esac
621 esac 638 esac
622 639
623 popd > /dev/null 640 popd > /dev/null
624} 641}
625 642
628# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 645# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
629# ebuilds. 646# ebuilds.
630kde4-meta_src_configure() { 647kde4-meta_src_configure() {
631 debug-print-function ${FUNCNAME} "$@" 648 debug-print-function ${FUNCNAME} "$@"
632 649
650 # backwards-compatibility: make mycmakeargs an array, if it isn't already
651 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
652 mycmakeargs=(${mycmakeargs})
653 fi
654
633 # Set some cmake default values here (usually workarounds for automagic deps) 655 # Set some cmake default values here (usually workarounds for automagic deps)
634 case ${KMNAME} in 656 case ${KMNAME} in
635 kdewebdev) 657 kdewebdev)
636 mycmakeargs=" 658 mycmakeargs=(
637 -DWITH_KdepimLibs=OFF 659 -DWITH_KdepimLibs=OFF
638 -DWITH_LibXml2=OFF 660 -DWITH_LibXml2=OFF
639 -DWITH_LibXslt=OFF 661 -DWITH_LibXslt=OFF
640 -DWITH_Boost=OFF 662 -DWITH_Boost=OFF
641 -DWITH_LibTidy=OFF 663 -DWITH_LibTidy=OFF
642 ${mycmakeargs}" 664 "${mycmakeargs[@]}"
665 )
666 ;;
667 koffice)
668 case ${PV} in
669 2.1.8[0-9]|2.1.9[0-9]|9999)
670 if [[ ${PN} != "kchart" ]]; then
671 mycmakeargs=(
672 -DBUILD_koreport=OFF
673 "${mycmakeargs[@]}"
674 )
675 fi
676 ;;
677 esac
643 ;; 678 ;;
644 esac 679 esac
645 680
646 kde4-base_src_configure 681 kde4-base_src_configure
647} 682}
651# General function for compiling split KDE4 applications. 686# General function for compiling split KDE4 applications.
652# Overrides kde4-base_src_compile. 687# Overrides kde4-base_src_compile.
653kde4-meta_src_compile() { 688kde4-meta_src_compile() {
654 debug-print-function ${FUNCNAME} "$@" 689 debug-print-function ${FUNCNAME} "$@"
655 690
656 kde4-base_src_compile 691 kde4-base_src_compile "$@"
657} 692}
658 693
659# @FUNCTION: kde4-meta_src_test 694# @FUNCTION: kde4-meta_src_test
660# @DESCRIPTION: 695# @DESCRIPTION:
661# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 696# Currently just calls its equivalent in kde4-base.eclass(5) if
662# ebuilds. 697# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
663kde4-meta_src_test() { 698kde4-meta_src_test() {
664 debug-print-function $FUNCNAME "$@" 699 debug-print-function $FUNCNAME "$@"
665 700
701 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
666 kde4-base_src_test 702 kde4-base_src_test
703 else
704 einfo "Tests disabled"
705 fi
667} 706}
668 707
669# @FUNCTION: kde4-meta_src_install 708# @FUNCTION: kde4-meta_src_install
670# @DESCRIPTION: 709# @DESCRIPTION:
671# Function for installing KDE4 split applications. 710# Function for installing KDE4 split applications.
672kde4-meta_src_install() { 711kde4-meta_src_install() {
673 debug-print-function $FUNCNAME "$@" 712 debug-print-function $FUNCNAME "$@"
674 713
714 # Search ${S}/${KMMODULE} and install common documentation files found
715 local doc
716 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
717 [[ -s "${doc}" ]] && dodoc "${doc}"
718 done
719
675 kde4-base_src_install 720 kde4-base_src_install
676} 721}
677 722
678# @FUNCTION: kde4-meta_src_make_doc
679# @DESCRIPTION:
680# This function searches in ${S}/${KMMODULE},
681# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
682kde4-meta_src_make_doc() {
683 debug-print-function ${FUNCNAME} "$@"
684
685 local doc
686 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
687 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
688 done
689
690 kde4-base_src_make_doc
691}
692
693# @FUNCTION: kde4-meta_pkg_postinst 723# @FUNCTION: kde4-meta_pkg_postinst
694# @DESCRIPTION: 724# @DESCRIPTION:
695# Display information about application handbook and invoke kbuildsycoca4. 725# Invoke kbuildsycoca4.
696kde4-meta_pkg_postinst() { 726kde4-meta_pkg_postinst() {
697 debug-print-function ${FUNCNAME} "$@" 727 debug-print-function ${FUNCNAME} "$@"
698
699 if has doc ${IUSE//+} && ! use doc; then
700 echo
701 einfo "Application handbook for ${PN} has not been installed."
702 einfo "To install handbook, reemerge =${CATEGORY}/${P} with 'doc' USE flag."
703 echo
704 fi
705 728
706 kde4-base_pkg_postinst 729 kde4-base_pkg_postinst
707} 730}
708 731
709# @FUNCTION: kde4-meta_pkg_postrm 732# @FUNCTION: kde4-meta_pkg_postrm

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.37

  ViewVC Help
Powered by ViewVC 1.1.20